con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


 f_lsb = 0.1220703125

  dhcp_wait = 1 
obj
  network : "UPNP_Interface_Top"
  node_IF : "Node_Interface"
  debug : "FullDuplexSerial"            
  timer : "System_Timer"

var
  byte ComConnected
  byte IP[4]
  byte SubnetMask[4]
  byte GatewayIP[4]
  byte DHCP_Server[4]
  byte DNS_Server[4]
  long time_cnt
  long sec_cnt
  long timer_running
  byte minutes
  long RTC_Ptr
  byte pc_buffer[256]
  byte nowPlaying[256]

  
pub TopLevelMain | Temp, i, index, addr, tmp
    i := 0
    addr := 0
    tmp := 0
    bytefill(@pc_buffer,0,256)
    bytefill(@nowPlaying,0,256)

    Timer.start
    PauseMSec(800)
    RTC_Ptr := Timer.GetTotalPtr
    debug.stop
    
    if ina[31] == 0
      repeat
        ComConnected := 0
        if ina[31] == 1
          debug.start(31,30,0,19200)
          ComConnected := 1
          PauseMSec(500) 'Wait for COG to load
          debug.tx($10)
          debug.tx($01)
          debug.str(string("Starting UPNP..."))
          quit
      while (Timer.getSeconds < 10)
      
    else  
      debug.start(31,30,0,19200)
      ComConnected := 1
      PauseMSec(500) 'Wait for COG to load
      debug.tx($10)
      debug.tx($01)
      debug.str(string("Starting UPNP..."))

    result := network.UPNP_Start(RTC_Ptr,@addr)

    if result > 0
      PauseMSec(10)
      if ComConnected == 1
        debug.str(string("OK",$0D))
        debug.str(string("DHCP Server..."))
      pauseMSec(10)
      if network.DHCP_OK == (-1)
        if ComConnected == 1
         debug.str(string("Not Found",$0D))
      else
        if ComConnected == 1
           debug.str(string("Found",$0D))
        GetAddresses
        PrintNetworkConfig
    else
      if ComConnected == 1
        debug.str(string("NIC INIT Routine Failed"))
        debug.tx($0D)
        debug.str(string("Result was "))
        debug.dec(result)
        debug.tx($0D)
      
    result := node_IF.init
    pauseMsec(500)
    if result == 0
      if ComConnected == 1
        debug.str(string("Node INIT Routine Failed"))
        debug.tx($0D)
    else
      if ComConnected == 1
        debug.str(string("Node INIT routine Complete"))
        debug.tx($0D)

    repeat index from 1 to 2
      i := node_IF.getTemp(index)
       Network.UpdateTemp(index,i)
    minutes := 0

    repeat
      if minutes <> timer.GetMinutes '(network.getTemp(0) == 1)
        minutes := timer.GetMinutes
        repeat index from 1 to 2
          i := node_IF.getTemp(index)
          Network.UpdateTemp(index,i)
'        network.getTemp(-1)

      if (network.DHCP_OK == (-1) and timer_running == 0)
        time_cnt := timer.GetMinutes
        timer_running := 1

      if timer_running == 1
        if timer.GetMinutes == time_cnt + DHCP_Wait
          if ComConnected == 1
            debug.tx($06)
            debug.str(string("Reattempting DHCP..."))
          network.stop
          result := network.UPNP_Start(RTC_Ptr, @addr)
          if ComConnected == 1
            debug.str(string("NIC restart result: "))
            debug.dec(result)
            debug.tx($0D)
          
          if network.DHCP_OK == (-1)
            if ComConnected == 1
             debug.str(string("DHCP Not Found",$0D))
          else
            if ComConnected == 1
              debug.str(string("DHCP Found",$0D))
            GetAddresses
            PrintNetworkConfig
          timer_running := 0    

      if sec_cnt <> timer.getSeconds
        sec_cnt := timer.getSeconds
        if ComConnected == 1
          debug.tx(11)
          debug.str(string("Up Time : "))
          debug.dec_(timer.getDays,2)
          debug.str(string(" Days "))
          debug.dec_(timer.getHours,2)
          debug.str(string(" Hours "))
          debug.dec_(timer.getMinutes,2)
          debug.str(string(" Minutes "))
          debug.dec_(sec_cnt,2)
          debug.str(string(" Seconds"))
          debug.tx($0D)
          debug.str(string("Pages Served: "))
          debug.dec_(network.getpagecount,5)
          debug.tx($0D)
          debug.tx($05)
          debug.tx($05)
'}
      if addr <> tmp
        tmp := addr
        debug.tx($0B)
'        debug.tx($06)
        debug.str(string("Debug Value: "))
        debug.hex(addr,2)
        debug.str(string(" Time: "))
        debug.dec(timer.getUpTime)
        debug.tx($0D)
        
      if ((timer.getUpTime == network.GetLeaseTime) and (network.GetLeaseTime <> -1))
        if ComConnected == 1
          debug.tx($06)
          debug.str(string("Renewing DHCP Lease..."))
        result := network.renewDHCPlease(RTC_Ptr)
        if result == 0
          if ComConnected == 1
            debug.str(string("OK",$0D))
          GetAddresses
          PrintNetworkConfig
        else
          if ComConnected == 1
            debug.str(string("Failed",$0D))
        
        
'}
        
'      if keyboard.gotkey
'        Temp := keyboard.key
'        case Temp
'          "0" :
'                 display.out($00)
'                 display.str(string("temperature : "))
'                 i := node_IF.getTemp($01)
'                 '0.010 V/F * 4 = 0.040 V/F
'                 '5/1024 = 4.8828125 mV/lsb
'                 '4.8828125/40 = 0.1220703125 F/lsb
'                 'T = 0.1220703125 * temperature
'                 i := math.ffloat(i)
'                 i := math.fmul(f_lsb, i)
'                 display.dec( math.fround(i))

pri GetAddresses
          network.getIP(@IP[0])
          network.getSubnetMask(@SubnetMask[0])
          network.GetGatewayIP(@GatewayIP[0])
          network.GetDNSServer(@DNS_Server[0])
          network.GetDHCPServer(@DHCP_Server[0])
pri PrintNetworkConfig
          debug.Str(string("IP         : "))
          debug.Dec(IP[0])
          debug.Str(string("."))
          debug.Dec(IP[1])
          debug.Str(string("."))
          debug.Dec(IP[2])
          debug.Str(string("."))
          debug.Dec(IP[3])
          debug.tx($0D)
    
          debug.Str(string("Subnet Mask: "))
          debug.Dec(SubnetMask[0])
          debug.Str(string("."))
          debug.Dec(SubnetMask[1])
          debug.Str(string("."))
          debug.Dec(SubnetMask[2])
          debug.Str(string("."))
          debug.Dec(SubnetMask[3])
          debug.tx($0D)
    
          debug.Str(string("Gateway IP : "))
          debug.Dec(GatewayIP[0])
          debug.Str(string("."))
          debug.Dec(GatewayIP[1])
          debug.Str(string("."))
          debug.Dec(GatewayIP[2])
          debug.Str(string("."))
          debug.Dec(GatewayIP[3])
          debug.tx($0D)
    
          debug.Str(string("DNS Server : "))
          debug.Dec(DNS_Server[0])
          debug.Str(string("."))
          debug.Dec(DNS_Server[1])
          debug.Str(string("."))
          debug.Dec(DNS_Server[2])
          debug.Str(string("."))
          debug.Dec(DNS_Server[3])
          debug.tx($0D)
    
          debug.Str(string("DHCP Server: "))
          debug.Dec(DHCP_Server[0])
          debug.Str(string("."))
          debug.Dec(DHCP_Server[1])
          debug.Str(string("."))
          debug.Dec(DHCP_Server[2])
          debug.Str(string("."))
          debug.Dec(DHCP_Server[3])
          debug.tx($0D)

          debug.str(string("DHCP Lease Expires: "))
          debug.dec(network.GetLeaseTime)
          debug.str(string(" seconds",$0D))
        
          debug.Str(string("Domain Name: "))
          debug.Str(network.GetDomainName)
          debug.tx($0D)        
pri PauseMSec(Duration)
''  Pause execution for specified milliseconds.
''  This routine is based on the set clock frequency.
''  
''  params:  Duration = number of milliseconds to delay                                                                                               
''  return:  none
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)